colour_cube_2 :-
   delete_all_screen_objects,     % (short form: daso) ; ready the scene.
   clss,
   new_screen_object(camera([location(20,20,20),look_at(0,0,0)])),
   new_screen_object(light_source([position( 100,0,0),colour(rgb(1,1,1))])),
   new_screen_object(light_source([position(0, 100,0),colour(rgb(1,1,1))])),
   new_screen_object(light_source([position(0,0, 100),colour(rgb(1,1,1))])),
   new_screen_object(light_source([position(10,10,10),colour(rgb(1,1,1))])),
   new_screen_object(light_source([position(0,0,0),colour(rgb(1,1,1))])),
   SideX = 8,  % Just to let you know, let's use a var (i.e. const)
   SideY = 8,
   SideZ = 8,
   % three nested 'for' loops...
   forall(  between(0,SideZ,I),   (      % 'for (I=0; I<=SideZ,I++) {
      BottomZ is SideZ - (SideZ-I)*2 -1, %eg SideZ=10 => -11 - +9
      UpperZ is SideZ - (SideZ-I)*2 +1,  %eg SideZ=10 => -9 - +11
      Red is 1.0 - (I/SideZ),
      forall(  between(0,SideY,J),    (
         BottomY is SideY - (SideY-J)*2 -1, 
         UpperY is SideY - (SideY-J)*2 +1,
         Green is 1.0 - (J/SideY),
         forall(  between(0,SideX,K),    (
            BottomX is SideX - (SideX-K)*2 -1, 
            UpperX is SideX - (SideX-K)*2 +1,
            Blue is 1.0 - (K/SideX),
            % save the boxes in a temporary place, to be retrieved later
            accumulate( box([ bc(vector(BottomX,BottomY,BottomZ)),
                              tc(vector(UpperX,UpperY,UpperZ)),
                              texture(pigment(colour(rgb(Red,Green,Blue))))
                           ])
            )
         ))
      ))
   )),
   % retrieve all the saved boxes...
   get_accumulator(Boxes),
   % clean up...
   clear_accumulator,
   % ... the 2 lines above may be written as 'get_and_clear_accumulator(Boxes)'

   % tell the system we've got a new object
   new_screen_object(difference([
                               union(Boxes),
                               cylinder([start(vector(-30,-30,-30)),
                                         end(vector(30,30,30)),
                                         radius(7),
                                         texture(pigment(colour(rgbf(1,1,1,1))))
                               ])
   ])).             
