%% 'cheap' version of my 'stone set in silver' necklace
%%  ^^^^^ i.e. no area_lights, few spheres, etc.
necklace :-
   daso,
   dont_display,
   writef('\nAnother cut-down version. This one renders *extremely* slowly\n'),
   writef('compared with comparable scenes like jade_ring.\n'),
   writef('For the sake of performance, no feedback is made to the screen.\n\n'),

   new_screen_object(camera([location(0,0,37),look_at(0,0,0)])),
   new_screen_object(light_source([position(20,20,20),colour(rgb(1,1,1))])),
   new_screen_object(light_source([position(-20,-5,20),colour(rgb(0.8,0.8,0.8))])),
   Positions = 2000, %% the number of spheres
   CPs =     [
              [ 0,   16, 0],       %% Top
              [ 0,   16, 0],
              [-1,   15, 0],
              [-2,   14, 2],
              [-3,   13,-3],
              [ 4,   12,-4],
              [ 4,   11, 4],
              [-5,   10, 5],
              [-5,    9,-5],
              [ 5,    8,-5],
              [ 5,    7, 5],
              [-5,    6, 5],
              [-6,    5,-6],
              [ 6,    3,-6],
              [ 6,    1, 6],
              [-6,    0, 6],
              [-6,   -1,-6],
              [ 6,   -2,-6],
              [ 6,   -3, 6],
              [-5,   -5, 5],
              [-5,   -7,-5],
              [ 5,   -8,-5],
              [ 5,   -9, 5],
              [-4,-10.5, 4],
              [-4,  -12,-4],
              [ 3,-13.5,-3],
              [ 0,  -16, 0],       %% Bottom
              [ 0,  -16, 0],       %% Bottom
              [-3.5,-13, 2.5],
              [-4.5,-11,-3.5],
              [ 5.5, -9,-4.5],
              [ 5.5, -7, 5.5],
              [-5.5, -5, 5.5],
              [-6.5, -2,-6.5],
              [ 6.5,  1,-6.5],
              [ 6.5,  3, 6.5],
              [-6.5,  5, 6.5],
              [-5.5,  7,-5.5],
              [ 5.5,  9,-5.5],
              [ 4.5,10.5, 4.5],
              [-4, 12, 4],
              [-3, 14,-3],
              [ 2, 15, 0],
              [ 0, 16, 0],
              [ 0, 16, 0]        %% end back on top
          ],
   spline(b_spline,CPs, Positions, Ps),
   !,
   clear_accumulator,
   forall( member(P,Ps),
      ( [X,Y,Z] = P,
        accumulate( sphere([centre(X,Y,Z),radius(0.2)]))
   )),
   accumulate(torus([maj_rad(0.6),min_rad(0.2),
      scale(1,1,1.5),rotate(90,-55,0),translate(0,16.5,0)])),
   get_and_clear_accumulator(Spheres),
   nso(union(union(Spheres),texture(['Silver_Texture']) )),
   nso(sphere([centre(0,0,0),radius(5),scale(1,3,1),
          texture([
             pigment([colour(rgb(0.7,0.7,0.7))]),
             finish([ambient(0.3),diffuse(0.6),crand(0.03)])
          ]),
          texture([
             pigment([
                granite, turbulence(0.0),
                colour_map([colour_entry(0,colour(rgbf(1,1,1,0))),
                            colour_entry(0.07,colour(rgbf(1,1,1,0))),
                            colour_entry(0.2,colour(rgbf(0.4,0.4,0.4,0))),
                            colour_entry(0.3,colour(rgbf(0.4,0.4,0.4,0))),
                            colour_entry(0.7,colour(rgbf(1,1,1,1))),
                            colour_entry(1.01,colour(rgbf(0.8,0.8,0.8,0)))
                ])
             ]),
             finish([crand(0.02)]),
             scale(9.0,4.1,2.6),rotate(0,0,40)
          ]),
          texture([
             pigment([
                granite, turbulence(0.0),
                colour_map([colour_entry(0,colour(rgbf(1,1,1,0))),
                            colour_entry(0.2,colour(rgbf(1,1,1,0.7))),
                            colour_entry(0.3,colour(rgbf(1,1,1,1))),
                            colour_entry(1.01,colour(rgbf(1,1,1,1)))
                ])
             ]),
             scale(5,4,2),rotate(0,0,-50)
          ]),
          texture([   %% Crack4 clone, but with a RED crack.
             pigment([
                marble, turbulence(0.85),
                colour_map([colour_entry(0,colour(rgbf(1,1,1,1))),
                            colour_entry(0.40,colour(rgbf(1,1,1,1))),
                            colour_entry(0.50,colour(rgbf(0.95,0.2,0.2,0.1))),
                            colour_entry(0.60,colour(rgbf(1,1,1,1))),
                            colour_entry(1.01,colour(rgbf(1,1,1,1)))
                ])
             ]),
             finish([phong(1),phong_size(90)]),
             scale(4.1,6,6),rotate(10,0,-20)
          ])
      ])),
   save('necklace.pov'),  %% save it.
   daso.                  %% 'garbage' collect
 
