spline_example :-
   dont_display,
   clss,daso,
   % ensure_loaded('b_spline_coeff'),
   % ensure_loaded('catmull_rom_coeff'),
   writef('\nCreating ''b_spline.pov'' and ''cr_spline.pov''\n'),
   writef('Please render in the normal way.\n\n'),
   new_screen_object(camera([location(80,80,80),look_at(0,0,0)])),
   new_screen_object(light_source([position( -10, 100, 100),colour(rgb(1,1,1))])),
   %% generate 20 control points.
   bagof( [X,Y,Z],
      I^(  between(1,20,I),
           X is random(100)-50.0,
           Y is random(100)-50.0,
           Z is random(100)-50.0
      ),
      CPs
   ),
   %% make a tiny box at each control point to show what we're doing.
   forall( member(P,CPs), 
      ( [X,Y,Z]=P,
        X1 is X-1, Y1 is Y-1, Z1 is Z-1,
        X2 is X+1, Y2 is Y+1, Z2 is Z+1,
        new_screen_object(box([bc(X1,Y1,Z1),tc(X2,Y2,Z2),
                          texture(pigment(colour(rgb(1,1,1))))]))
      )),
   %% calculate the bspline points. 200 of them
   spline(b_spline,CPs,200,NPs),
   %% create 200 spheres on the bspline curve. Do it the slow way.
   forall( nmember(P,NPs,N), 
      ( [X,Y,Z]=P,
        N2 is N/200.0,
        R is N2,
        G is 1.0 - (N2*N2),
        B is N2,
        new_screen_object(sphere([centre(X,Y,Z),radius(1),
                          texture(pigment(colour(rgb(R,G,B))))]))
      )),
   save_povray2('b_spline.pov'),
   daso,clss,
   new_screen_object(camera([location(80,80,80),look_at(0,0,0)])),
   new_screen_object(light_source([position( -10, 100, 100),colour(rgb(1,1,1))])),
   %% make a tiny box at each control point to show what we're doing.
   forall( member(P,CPs), 
      ( [X,Y,Z]=P,
        X1 is X-1, Y1 is Y-1, Z1 is Z-1,
        X2 is X+1, Y2 is Y+1, Z2 is Z+1,
        new_screen_object(box([bc(X1,Y1,Z1),tc(X2,Y2,Z2),
                          texture(pigment(colour(rgb(1,1,1))))]))
      )),
   %% calculate the catmull_rom spline points. 200 of them
   spline(cr_spline,CPs,200,NP2s),
   %% Turn the display back on.
   do_display,
   %% create 200 spheres on the bspline curve. Do it the slow way.
   forall( nmember(P,NP2s,N), 
      ( [X,Y,Z]=P,
        N2 is N/200.0,
        R is N2,
        G is 1.0 - (N2*N2),
        B is N2,
        new_screen_object(sphere([centre(X,Y,Z),radius(1),
                          texture(pigment(colour(rgb(R,G,B))))]))
      )),
   save_povray2('cr_spline.pov'),
   true.
