sky_vector_given_positions(P1,P2,P3,TimeDiff,Result) :-
   vector_difference(P2,P1,V1),
   vector_difference(P3,P2,V2),
   acceleration(V1,V2,TimeDiff,Result).
positions_acceleration_timediff_to_sky_vector(P1,P2,P3,Acc,TimeDiff,Result) :-
   vector_difference(P2,P1,V1),
   vector_difference(P3,P2,V2),
   acceleration(Acc,V1,V2,TimeDiff,Result).
acceleration(V1,V2,TimeDiff,Result) :-
   %% Assume a gravity of 9.8 m/s/s
   acceleration(vector(0,-9.8,0),V1,V2,TimeDiff,Result).
%% G = gravity, V1 velocity at T1, T2 at T2, TimeDIff=T2-T1
acceleration(G,V1,V2,TimeDiff,Result) :-
   ( vector(Gx,Gy,Gz) = G ; [Gx,Gy,Gz] = G),
   ( vector(V1x,V1y,V1z) = V1 ; [V1x,V1y,V1z] = V1),
   ( vector(V2x,V2y,V2z) = V2 ; [V2x,V2y,V2z] = V2),
   !,
   Dx is (V2x-V1x) / TimeDiff,
   Dy is (V2y-V1y) / TimeDiff,
   Dz is (V2z-V1z) / TimeDiff,
   Rx is -Gx + Dx,
   Ry is -Gy + Dy,
   Rz is -Gz + Dz,
   Result = [Rx, Ry, Rz].

