
%:- module(demo_dialog,
%     [ dialog/0
%     , demo_dialog/1
%     ]).

%:- use_module(library(pce)).
%:- require([ send_list/3
%      ]).

dialog :-
   new(D, dialog('Capov! 0.31')),
                    % menu_bar
   send(D, append, new(MB, menu_bar)),
   send(MB, append, new(FILE, popup(file))),
   % send(MB, append, new(EDIT, popup(edit))),
   % send(MB, append, new(CREATE, popup(create))),
   % send(MB, append, new(DISPLAY, popup(display))),
   send(MB, append, new(RELOAD, popup(reload))),
   send(MB, append, new(DELETE, popup(delete))),
   send(MB, append, new(EXAMPLES, popup(examples))),
   send(MB, append, new(HELP, popup(help))),
   send_list(FILE, append,
        [% menu_item(save, message(@prolog,save)),
         % menu_item(dump, message(@prolog,dump)),
          menu_item('Save as..', message(@prolog,file_menu)),
         % menu_item(load, message(@prolog,load_dialog)),
         % menu_item(include, message(@prolog,include_dialog)),
          menu_item(quit_pce,
               message(@pce, die))
        ]),
   /*
   send_list(EDIT, append,
        [ menu_item(cut,
               message(@pce, write_ln, 'Cut'))
        , menu_item(copy,
               message(@pce, write_ln, 'Copy'),
               @default, @on)
        , menu_item(paste,
               message(@pce, write_ln, 'Paste'))
        ]),
   */
   send_list(DELETE, append,
        [ menu_item(objects,
               message(@prolog, daso)),
          menu_item(declares,
               message(@prolog, dad)),
          menu_item(spheres,
               message(@prolog, dsot, sphere)),
          menu_item(boxes,
               message(@prolog, dsot, box)),
          menu_item(planes,
               message(@prolog, dsot, plane)),
          menu_item(cylinders,
               message(@prolog, dsot, cylinder)),
          menu_item(cones,
               message(@prolog, dsot, cone)),
          menu_item(torii,
               message(@prolog, dsot, torus)),
          menu_item(unions,
               message(@prolog, dsot, union)),
          menu_item(differences,
               message(@prolog, dsot, difference)),
          menu_item(intersections,
               message(@prolog, dsot, intersection))
        ]),
   send_list(RELOAD, append,
        [ menu_item('dialog',
               message(@prolog, capov_load,'system/dialog')),
          menu_item('display',
               message(@prolog, capov_load,'system/display')),
          menu_item('graphics',
               message(@prolog, capov_load,'system/graphics')),
          menu_item('misc',
               message(@prolog, capov_load,'system/misc')),
          menu_item('option',
               message(@prolog, capov_load,'system/option')),
          menu_item('save_pov',
               message(@prolog, capov_load,'system/save_pov')),
          menu_item('spline',
               message(@prolog, capov_load,'system/spline')),
          menu_item('spline_coeff',
               message(@prolog, capov_load,'system/spline_coeff')),
          menu_item('system',
               message(@prolog, capov_load,'system/system')),
          menu_item('sys_grap',
               message(@prolog, capov_load,'system/sys_grap'))
        ]),
   /*
   send_list(D, append,
        [ text_item(user, @pce?user,
               message(@prolog, writef, 'Hello %s\n', @arg1))
        , slider(speed, 0, 100, 20,
            message(@prolog, writef, 'Speed %t\n', @arg1))
        ]),
   send(D, append, new(M, menu(fill_pattern, marked,
                message(@prolog, writef,
                   'Fill with %d\n', @arg1)))),
   */
   send_list(EXAMPLES, append,
        [ menu_item('basics', and(
               message(@prolog, capov_load,'examples/basic_test'),
               message(@prolog, basic_test))),
          menu_item('spline_example', and(
               message(@prolog, capov_load,'examples/spline_example'),
               message(@prolog, spline_example))),
          menu_item('colour_cube_1', and(
               message(@prolog, capov_load,'examples/colour_cube_1'),
               message(@prolog, colour_cube_1))),
          menu_item('colour_cube_2', and(
               message(@prolog, capov_load,'examples/colour_cube_2'),
               message(@prolog, colour_cube_2))),
          menu_item('colour_cube_3', and(
               message(@prolog, capov_load,'examples/colour_cube_3'),
               message(@prolog, colour_cube_3))),
          menu_item('jade_ring', and(
               message(@prolog, capov_load,'examples/jade_ring'),
               message(@prolog, jade_ring))),
          menu_item('metals_ring', and(
               message(@prolog, capov_load,'examples/metal_ring'),
               message(@prolog, metal_ring))),
          menu_item('necklace', and(
               message(@prolog, capov_load,'examples/necklace'),
               message(@prolog, necklace)))
        ]),
   
   send_list(HELP, append,
        [ menu_item('user guide', 
               message(@prolog, shell, 'more docs/user.guide'))
         , menu_item('useful commands', 
               message(@prolog, shell, 'more docs/useful_commands.txt'))
        ]),
        /*
   send(M, layout, horizontal),
   fill_pattern_menu(M),
        */ 
   send_list(D, append,
        %[ button(ok, message(@pce, write_ln, ok))
        [ button('zoom...', message(@prolog, zoom))
        , button(redraw, message(@prolog, redraw))
        , button('display...', message(@prolog, display_things))
        , button('create...', message(@prolog, create))
        , button(quit, message(D, destroy))
        ]),

   send(D, open).

more(A) :-
   swritef(String,'more %t',[A]),
   shell(String).

demo_dialog(D) :-
   new(D, dialog('Capov! 0.31')),
                    % menu_bar
   send(D, append, new(MB, menu_bar)),
   send(MB, append, new(FILE, popup(file))),
   send(MB, append, new(EDIT, popup(edit))),
   % send(MB, append, new(CREATE, popup(create))),
   % send(MB, append, new(DISPLAY, popup(display))),
   send(MB, append, new(RELOAD, popup(reload))),
   send(MB, append, new(DELETE, popup(delete))),
   send(MB, append, new(EXAMPLES, popup(examples))),
   send_list(FILE, append,
        [ menu_item(save, message(@prolog,save)),
          menu_item(dump, message(@prolog,dump)),
          menu_item('Save as..', message(@prolog,file_menu)),
          menu_item(load, message(@prolog,load_dialog)),
          menu_item(include, message(@prolog,include_dialog)),
          menu_item(quit_pce,
               message(@pce, die))
        ]),
   send_list(EDIT, append,
        [ menu_item(cut,
               message(@pce, write_ln, 'Cut'))
        , menu_item(copy,
               message(@pce, write_ln, 'Copy'),
               @default, @on)
        , menu_item(paste,
               message(@pce, write_ln, 'Paste'))
        ]),
   send_list(DELETE, append,
        [ menu_item(objects,
               message(@prolog, daso)),
          menu_item(declares,
               message(@prolog, dad)),
          menu_item(spheres,
               message(@prolog, dsot, sphere)),
          menu_item(boxes,
               message(@prolog, dsot, box)),
          menu_item(planes,
               message(@prolog, dsot, plane)),
          menu_item(cylinders,
               message(@prolog, dsot, cylinder)),
          menu_item(cones,
               message(@prolog, dsot, cone)),
          menu_item(torii,
               message(@prolog, dsot, torus)),
          menu_item(unions,
               message(@prolog, dsot, union)),
          menu_item(differences,
               message(@prolog, dsot, difference)),
          menu_item(intersections,
               message(@prolog, dsot, intersection))
        ]),
   send_list(RELOAD, append,
        [ menu_item('dialog',
               message(@prolog, capov_load,'system/dialog')),
          menu_item('display',
               message(@prolog, capov_load,'system/display')),
          menu_item('graphics',
               message(@prolog, capov_load,'system/graphics')),
          menu_item('misc',
               message(@prolog, capov_load,'system/misc')),
          menu_item('option',
               message(@prolog, capov_load,'system/option')),
          menu_item('save_pov',
               message(@prolog, capov_load,'system/save_pov')),
          menu_item('spline',
               message(@prolog, capov_load,'system/spline')),
          menu_item('spline_coeff',
               message(@prolog, capov_load,'system/spline_coeff')),
          menu_item('system',
               message(@prolog, capov_load,'system/system')),
          menu_item('sys_grap',
               message(@prolog, capov_load,'system/sys_grap')),
          menu_item('test',
               message(@prolog, capov_load,'examples/test'))
        ]),
   
   send_list(D, append,
        [ text_item(user, @pce?user,
               message(@prolog, writef, 'Hello %s\n', @arg1))
        , slider(speed, 0, 100, 20,
            message(@prolog, writef, 'Speed %t\n', @arg1))
        ]),

   send(D, append, new(M, menu(fill_pattern, marked,
                message(@prolog, writef,
                   'Fill with %d\n', @arg1)))),
   send_list(EXAMPLES, append,
        [ menu_item('basics', and(
               message(@prolog, capov_load,'examples/basic_test'),
               message(@prolog, basic_test))),
          menu_item('spline_example', and(
               message(@prolog, capov_load,'examples/spline_example'),
               message(@prolog, spline_example))),
          menu_item('colour_cube_1', and(
               message(@prolog, capov_load,'examples/colour_cube_1'),
               message(@prolog, colour_cube_1))),
          menu_item('colour_cube_2', and(
               message(@prolog, capov_load,'examples/colour_cube_2'),
               message(@prolog, colour_cube_2))),
          menu_item('colour_cube_3', and(
               message(@prolog, capov_load,'examples/colour_cube_3'),
               message(@prolog, colour_cube_3))),
          menu_item('jade_ring', and(
               message(@prolog, capov_load,'examples/jade_ring'),
               message(@prolog, jade_ring))),
          menu_item('metals_ring', and(
               message(@prolog, capov_load,'examples/metal_ring'),
               message(@prolog, metal_ring))),
          menu_item('necklace', and(
               message(@prolog, capov_load,'examples/necklace'),
               message(@prolog, necklace)))
        ]),

   send(M, layout, horizontal),
   fill_pattern_menu(M),

   send_list(D, append,
        [ button(ok, message(@pce, write_ln, ok))
        , button(quit, message(D, destroy))
        ]),

   send(D, open).

fill_pattern(@white_image).
fill_pattern(@grey12_image).
fill_pattern(@grey25_image).
fill_pattern(@grey50_image).
fill_pattern(@grey75_image).
fill_pattern(@black_image).


fill_pattern_menu(M) :-
   fill_pattern(Pattern),
   send(M, append, menu_item(Pattern, @default, Pattern)),
   fail ; true.
