% :- dynamic window_exist/1.
top_level :-
   dialog.
top_level2 :-
   new(D,dialog('Main window')),
   new(E, dialog),
   send(E, below, D),
   new(F, dialog),
   send(F, below, E),
   send(D, append, button('create...', message(@prolog,create))),
   send(D, append, button('zoom...', message(@prolog,zoom))),
   send(D, append, button('file...', message(@prolog,file_menu))),
   send(E, append, button(redraw, message(@prolog,redraw))),
   % send(E, append, button(redraw, and( message(@prolog,clss),
   %               % message(@prolog,display_objects), taken care of by clss?
   %               message(@prolog,display_objects)))),
   send(E, append, button(dad,  and( message(@prolog,delete_all_declareds),
                 message(@prolog,write_ln,'Deleting all declareds...')))),
   send(E, append, button(daso, and( message(@prolog,delete_all_screen_objects),
                 message(@prolog,write_ln,'Deleting all screen objects...')))),
   send(F, append, button('display...', message(@prolog, display_things))),

   % send(F, append, button(cancel, message(D, destroy))),
   add_cancel_button(F),
   send(F, default_button, cancel),
   send(D,open).

display_things :-
   new(D,dialog('Display Hierarchies')),
   new(E, dialog),
   send(E, below, D),
   send(D, append, button('source', 
                          message(@prolog,display_source_objects_hierarchy))),
   send(D, append, button('included', 
                          message(@prolog,display_included_objects_hierarchy))),
   send(E, append, button('declareds', 
                          message(@prolog,display_declareds_hierarchy))),
   send(E, append, button(cancel, message(D, destroy))),
   send(D,open).

file_menu :-
   new(D,dialog('File menu')),
   send(D, append, new(label)),
   send(D, append, new(FileName, text_item('file name'))),
   send(D, append,
        button('save',
            if(FileName?selection == '',
               message(@prolog, save_povray2),
               message(@prolog, save_povray2, FileName?selection)))),
   send(D, append,
        button('dump',
            if(FileName?selection == '',
                  message(@prolog, dump),
                  message(@prolog, dump, FileName?selection)))),
   send(D, append,
        button('restore',
            if(FileName?selection == '',
                  message(@prolog, restore_prolog),
                  message(@prolog, restore_prolog, FileName?selection)))),
   send(D, append, button(cancel, message(D, destroy))),
   send(D, append, button(done,   message(D, destroy))),  % aren't they similar!

   send(D, default_button, done),
   send(D,open).

create :-
   new(D,dialog('Simple object creation')),
   send(D, append, new(label)),
   send(D, append, new(Name, text_item('declare name'))),
   send(D, append, new(Object, text_item('object description'))),
   send(D, append, button('declare',
      if(Name?selection == '',
         message(D, report, warning, 'Please enter a name for declare!'),
         /*if((term_to_atom(Dummy,Name?selection), Dummy =.. [_,_|_]),
            message(D, report, warning, 'No GUI for parameterised declares!'),*/
            if(Object?selection == '',
               message(D, report, warning, 'Please enter a description!'),
               message(@prolog, new_declared2, D, Name?selection, Object?selection)
         )))),
   send(D, append, button('object', 
      if(Object?selection == '',
         message(D, report, warning, 'Please enter an object description!'),
         message(@prolog, new_screen_object2, Object?selection)))),
   send(D, append, button(done, message(D, destroy))),

   send(D, default_button, done),
   send(D,open).

% Zooming box
zoom :-
   win_scale(xyWindow,S1), Sxy is 10*S1,
   win_scale(zyWindow,S2), Szy is 10*S2,
   win_scale(xzWindow,S3), Sxz is 10*S3,

   new(P, dialog('Zoomin'' ')),

   send(P, display, new(B1, box(Szy,Szy)), point(40,40)),
   send(P, display, new(B2, box(Sxy,Sxy)), point(140,40)),
   send(P, display, new(B3, box(Sxz,Sxz)), point(140,140)),
   send(B1, recogniser, new(resize_gesture)),
   send(B2, recogniser, new(resize_gesture)),
   send(B3, recogniser, new(resize_gesture)),

   new(D, dialog),
   send(D, below, P),
   send(D, append, new(S, slider('ZY Window', 0, 200, 0, @nil))),
   new(_, constraint(B1, S, identity(height, selection))),
   new(_, constraint(B1, S, identity(width, selection))),

   new(E, dialog),
   send(E, below, D),
   send(E, append, new(T, slider('XY Window', 0, 200, 0, @nil))),
   new(_, constraint(B2, T, identity(height, selection))),
   new(_, constraint(B2, T, identity(width, selection))),

   new(F, dialog),
   send(F, below, E),
   send(F, append, new(U, slider('XZ Window', 0, 200, 0, @nil))),
   new(_, constraint(B3, U, identity(height, selection))),
   new(_, constraint(B3, U, identity(width, selection))),
   send(F, append, new(_, button('test', and(
                                  message(@prolog, new_win_scales, T?selection, 
                                                                   S?selection, 
                                                                   U?selection),
                                  message(@prolog, clss), 
                                  message(@prolog, display_objects))
         ))),
   send(F, append, new(_, button(cancel, message(P, destroy)))),
   send(F, append, new(_, button(done, and(
                                  message(@prolog, new_win_scales, T?selection, 
                                                                   S?selection, 
                                                                   U?selection),
                                  %message(@prolog, clss), 
                                  %message(@prolog, display_objects),
                                  message(P, destroy)
         )))),
   send(P, open).

%%%%%%%% Hierarchical displays of objects and things in general
display_included_objects_hierarchy :-
   new(Hierarchy, picture('Hierarchy of included objects',size(400,200))),
   send(Hierarchy, display, tree(new(Win, node(text('included objects'))))),
   new(Below, dialog),
   send(Below, below, Hierarchy),
   add_cancel_button(Below),
   send(Hierarchy, open),
   (  screen_object(included,_)
   -> forall( recorded(source, Obj), expand_objects_hierarchy(Obj,Win))
   ;  send(Win, son, new(_, node(text('None!'))))
   ).

display_source_objects_hierarchy :-
   new(Hierarchy, picture('Hierarchy of objects',size(400,200))),
   send(Hierarchy, display, tree(new(Win, node(text('source objects'))))),
   new(Below, dialog),
   send(Below, below, Hierarchy),
   add_cancel_button(Below),
   send(Hierarchy, open),
   (  recorded(source,_)
   -> forall( recorded(source, Obj), expand_objects_hierarchy(Obj,Win))
   ;  send(Win, son, new(_, node(text('None!'))))
   ).

display_declareds_hierarchy :-
   new(Hierarchy, picture('Hierarchy of declares',size(700,400))),
   send(Hierarchy, display, tree(new(Node, node(text('declares'))))),
   new(Below, dialog),
   send(Below, below, Hierarchy),
   add_cancel_button(Below),
   send(Hierarchy, open),
   (  declared(_,_,_,_)
   -> setof( Included-Types,
         _A1^_A2^_A3^(
            declared(Included,_A1,_A2,_A3),
            Type^setof( Type, 
                        _B1^_B2^declared(Included,_B1,Type,_B2),
                        Types
            )
         ),
         Declares
      ),
      forall( member(Incl-Typs,Declares),
         (  send(Node, son, new(Node1, node(text(Incl)))),
            forall( member(Typ, Typs),
               (  send(Node1, son, new(Node2, node(text(Typ)))),
                  forall( declared(Incl,N,Typ,B),
                     ( option(hierarchy,names_only)
                     -> send(Node2, son, new(_, node(text(N))))
                     ;  swritef(String,'%d = %t',[N,B]),
                        send(Node2, son, new(_, node(text(String))))
                     )
                  )
               )
            )
         )
      )
   ;  send(Node, son, new(_, node(text('None!'))))
   ).

display_included_declareds_hierarchy :-
   new(Hierarchy, picture('Hierarchy of included declares',size(400,200))),
   send(Hierarchy, display, tree(new(Win, node(text('included declares'))))),
   new(Below, dialog),
   send(Below, below, Hierarchy),
   add_cancel_button(Below),
   send(Hierarchy, open),
   (  declared(included,_,_,_)
   -> forall( declared(included, Obj,_,_), expand_objects_hierarchy(Obj,Win))
   ;  send(Win, son, new(_, node(text('None!'))))
   ).

expand_objects_hierarchy(Obj,Win) :-
   Obj =.. [Type,Bods],
   member(Type,[union,merge,difference,intersection]),
   !,
   send(Win, son, new(Node, node(text(Type)))),
   length(Bods,Len),
   (  Len > 30
   -> send(Node, son, new(_, node(text(string('Lots of objects (%s)',Len)))))
   ;  forall( member(O,Bods), expand_objects_hierarchy_2(O,Node))
   ).
expand_objects_hierarchy(Desc, Win) :-
   Desc =.. [Obj,Bod],
   !,
   ( option(hierarchy,names_only)
   -> send(Win, son, new(_, node(text(Obj))))
   ;  swritef(String,'%d = %t',[Obj,Bod]),
      send(Win, son, new(_, node(text(String))))
   ).
   % send(Win, son, new(_, node(text(string('%s %s',Obj,Bod))))).
   % send(Win2, son, new(_, node(text(string('%s',Bod))))).
expand_objects_hierarchy(Obj,Win) :-
   Obj =.. [Obj],
   % send(Win, son, new(Node, node(text(Obj)))).
   send(Win, son, node(text(Obj))).
%%%%%%%% Hierarchical displays of objects and things in general end

/*
box_with_slider :-
   new(P, picture('Object editor')),
   send(P, display, new(B, box(50,50)), point(40,40)),
   send(P, display, new(C, box(50,50)), point(150,40)),
   send(B, recogniser, new(resize_gesture)),
   send(C, recogniser, new(resize_gesture)),

   new(D, dialog),
   send(D, below, P),
   send(D, append, new(S, slider(x, 0, 500, 0, @nil))),
   new(_, constraint(B, S, identity(width, selection))),

   new(E, dialog),
   send(E, below, D),
   send(E, append, new(S2, slider(y, 0, 200, 0, @nil))),
   new(_, constraint(B, S2, identity(height, selection))),
   new(_, constraint(C, S2, identity(height, selection))),

   new(F, dialog),
   send(F, below, E),
   send(F, append, new(S3, slider(z, 0, 200, 0, @nil))),
   new(_, constraint(C, S3, identity(width, selection))),

   send(P, open).
*/
/*
:- pce_begin_class(text_box(string, width, height), device).
   
initialise(T, S:string Width:[int], Height:[int]) :->
      "Initialise from string, width and heigth"::
      default(Width, 100, W),
      default(Height, 50, H),
      send(T, send_super, initialise),
      send(T, display, box(W,H)),
      send(T, display, new(T, text(S, center))),
      send(T, recenter).
   
recenter(T) :->
   "Put text in center of box"::
      send(T?text_member, center, T?box_member).
   
   string(T, S:string) :->
      "Set the string of the text"::
      send(T?text_member, string, S).
   
   string(T, S) :<-
      "Get the string of the text"::
      get(T?text_member, string, S).
   
:- pce_end_class.

twd:-
   new(A, picture),
   send(A, display, new(B, box(100, 100)), point(10, 10)),
   send(A, display, new(C, circle(50)), point(150, 20)),

   set_height_dialog(E, B),
   set_width_dialog(D, B),
   send_list([B,C], recogniser, 
              click_gesture(left, '', single, and(message(E, context, @receiver),
                                                  message(D, context, @receiver)))),
   send(E, below, A),
   send(D, below, A),

   send(A, open).

set_height_dialog(A, Graphical) :-
   new(A, dialog('Set Height')),
   send(A, attribute, attribute(ctx, @nil)),
   send(A, send_method, 
           send_method(context, 
              vector(graphical), 
              and(message(A, ctx, @arg1), 
                  message(@prolog, write_ln, yeehaw), 
                  message(?(A, member, height), 
                            selection, @arg1?height), 
                  message(A, report, status, 'Attached to %s', @arg1?name)))),
   send(A, get_method, 
                get_method(context, 'graphical*', new(vector), A?ctx)),
   send(A, append, new(label)),
   send(A, append, new(C, 
                      slider(height, 0, 100, 0, message(A?ctx, height, @arg1)))),
   send(C, drag, @on),
   send(A, context, Graphical).

set_width_dialog(A, Graphical) :-
   new(A, dialog('Set Width')),
   send(A, attribute, attribute(ctx, @nil)),
   send(A, send_method, 
           send_method(context, 
              vector(graphical), 
              and(message(A, ctx, @arg1), 
                  message(?(A, member, width), 
                            selection, @arg1?width), 
                  message(A, report, status, 'Attached to %s', @arg1?name)))),
   send(A, get_method, 
                get_method(context, 'graphical*', new(vector), A?ctx)),
   send(A, append, new(label)),
   send(A, append, new(C, 
                      slider(width, 0, 100, 0, message(A?ctx, width, @arg1)))),
   send(C, drag, @on),
   send(A, context, Graphical).
%**************************
create_fill_pattern_dialog :-
   new(Dialog, dialog('Fill Patterns')),
   send(Dialog, append, new(M, menu(fill_pattern, 
                               marked, 
                               message(@prolog, write_ln, @arg1)))),
   send_list(M, append, [menu_item(white, @default, @white_image),
                         menu_item(grey12, @default, @grey12_image),
                         menu_item(grey25, @default, @grey25_image),
                         menu_item(grey50, @default, @grey50_image),
                         menu_item(grey75, @default, @grey75_image),
                         menu_item(black, @default, @black_image)]),
   send(Dialog, open).
%**************************

make_same_width(Gr1, Gr2) :-
   send(Gr1, width, Gr2?width).

create_person_dialog :-
   new(D, dialog('Enter new person')),
   send(D, append, new(label)),
   send(D, append, new(B, text_item(name))),
   send(D, append, new(Age, text_item(age))),
   send(D, append, new(Sex, menu(sex, marked))),
   send(Sex, append, female),
   send(Sex, append, male),
   send(Age, type, int),
   send(D, append, button(create, message(@prolog, 
                                                create_person, 
                                                B?selection, 
                                                Age?selection, 
                                                Sex?selection))),
   send(D, default_button, create),
   send(D, open).

create_person(A, B, C) :-
   format('Creating ~w person ~w of ~d years old~n', [C,A,B]).
*/
add_cancel_button(Win) :-
   send(Win, append, button(cancel, message(Win, destroy))).

