init_curves :-
   Resolution = 100,  %% i.e. delta-t is 1/Resolution, or 100 points
   write('Creating Hermite, bezier, b-spline and Catmull-Rom blending function coefficients...'),nl,
   tell('spline_coeff.pl'),
   write('%% ''t'' has been scaled by 100 for reasons of efficiency.'),nl,
   forall(  between(0,Resolution,I),
      (  T is I*1.0/Resolution,
         Teff is integer(T*100),
         T2 is T*T,
         T3 is T2*T,
         P1 is 2*T3-3*T2+1,
         P2 is -2*T3+2*T2,
         P3 is T3-2*T2+T,
         P4 is T3-T2,
         writef('spline_coefficient(hermite,%t,%t,%t,%t,%t).\n',[Teff,P1,P2,P3,P4])
      )
   ),
   forall(  between(0,Resolution,I),
      (  T is I*1.0/Resolution,
         Teff is integer(T*100),
         T_1 is 1-T,
         T_12 is T_1*T_1,
         T_13 is T_12*T_1,
         T2 is T*T,
         P1 is T_13,
         P2 is 3*T*T_12,
         P3 is 3*T2*T_1,
         P4 is T2*T,
         writef('spline_coefficient(bezier,%t,%t,%t,%t,%t).\n',[Teff,P1,P2,P3,P4])
      )
   ),
   forall(  between(0,Resolution,I),
      (  T is I*1.0/Resolution,
         Teff is integer(T*100),
         T2 is T*T,
         T3 is T2*T,
         P1 is (-T3+3*T2-3*T+1)/6.0,
         P2 is (3*T3-6*T2+4)/6.0,
         P3 is (-3*T3+3*T2+3*T+1)/6.0,
         P4 is T3/6.0,
         writef('spline_coefficient(b_spline,%t,%t,%t,%t,%t).\n',[Teff,P1,P2,P3,P4])
      )
   ),
   forall(  between(0,Resolution,I),
      (  T is I*1.0/Resolution,
         Teff is integer(T*100),
         T2 is T*T,
         T3 is T2*T,
         P1 is (-T3+2*T2-T)/2.0,
         P2 is (3*T3-5*T2+2)/2.0,
         P3 is (-3*T3+4*T2+T)/2.0,
         P4 is (T3-T2)/2.0,
         writef('spline_coefficient(cr_spline,%t,%t,%t,%t,%t).\n',[Teff,P1,P2,P3,P4])
      )
   ),
   told,
   write('Finished. Now what?'),nl.
