:- arithmetic_function(degs_to_rads/1).
:- arithmetic_function(degs_sin/1).
:- arithmetic_function(degs_cos/1).

:- dynamic window_exist/1.
:- dynamic screen_object/2.
% :- dynamic declared/3.
%:- dynamic declared/4.
%:- dynamic include_files/1.   % #include wot files?
%:- dynamic capov/2.          % capov globals - i.e. system vars, if you like
%:- dynamic win_scale/2.      % this line is not required for swi xpce
%:- dynamic win_centre/2.     % this line is not required for swi xpce
%:- dynamic temporary_accumulating/1.
%:- multifile(declared/4).

:- flag(reading_file,_,source). % needs deleting (eventually)

% dummy is included for debugging purposes - spy(dummy)
dummy.

% :- flag(win_scale_xy,_,500).
% :- flag(win_scale_zy,_,500).
% :- flag(win_scale_xz,_,500).
win_centre(xyWindow,[140,90]).
win_centre(zyWindow,[140,90]).
win_centre(xzWindow,[140,90]).

accumulate(A) :-
   recordz(temporary_accumulating,A).
get_accumulator(As) :-
   bagof(A,recorded(temporary_accumulating,A),As).
clear_accumulator :-
   recorded(temporary_accumulating,_,R),
   erase(R),
   fail
   ; true. 
   % retractall(temporary_accumulating(_)).
get_and_clear_accumulator(As) :-
   get_accumulator(As),
   clear_accumulator.

new_win_scales(Z1,Z2,Z3) :-
   Z11 is Z1 * 10,
   Z12 is Z2 * 10,
   Z13 is Z3 * 10,
   flag(win_scale_xy,_,Z11),
   flag(win_scale_zy,_,Z12),
   flag(win_scale_xz,_,Z13).
win_scale(xyWindow,SR) :- flag(win_scale_xy,S,S), SR is S / 100.0.
win_scale(zyWindow,SR) :- flag(win_scale_zy,S,S), SR is S / 100.0.
win_scale(xzWindow,SR) :- flag(win_scale_xz,S,S), SR is S / 100.0.

message(_Window,Message) :-
   write(Message),nl.
  /* ( \+ window_exist(errorWindow)
   -> open_text_window(errorWindow,'Error/Warning Messages',300,100)
   ;  true
   ),
   send(@Window*/

dad :- delete_all_declareds.
delete_all_declareds :- 
   recorded(declared,[_,_,_,_],Ref), erase(Ref), fail
   ; true.
   % retractall(declared(not_included,_,_,_)).

daso :- delete_all_screen_objects.
delete_all_screen_objects :- % retractall(screen_object(_,_)).
   recorded(source,_,A), erase(A), fail  ;
   recorded(included,_,A), erase(A), fail  ;
   true.

init_system :- initialize_system.
% initialize :-
%    retractall(window_handle(_,_)),
%    open_picture_window(xzWindow,'XZ Plane'),
%   open_picture_window(viewWindow,'Perspective View'),
%    open_picture_window(xyWindow,'XY Plane'),
%    open_picture_window(zyWindow,'ZY Plane'),
%    draw_axis,
%    top_level.

% draw_axis :-
%    option(window_size,Size),
%    win_centre(xyWindow,[X_1,Y_1]),
%    win_centre(zyWindow,[Z_2,Y_2]),
%    win_centre(xzWindow,[X_3,Z_3]),
%    Xxy_1 is X_1 - Size, Xxy_2 is X_1 + Size,
%    Yxy_1 is Y_1 - Size, Yxy_2 is Y_1 + Size,
%    Zzy_1 is Z_2 - Size, Zzy_2 is Z_2 + Size,
%    Yzy_1 is Y_2 - Size, Yzy_2 is Y_2 + Size,
%    Xxz_1 is X_3 - Size, Xxz_2 is X_3 + Size,
%    Zxz_1 is Z_3 - Size, Zxz_2 is Z_3 + Size,
%    send(@xyWindow,display,line(Xxy_1,Y_1,Xxy_2,Y_1)),
%    send(@xyWindow,display,line(X_1,Yxy_1,X_1,Yxy_2)),
%    send(@zyWindow,display,line(Zzy_1,Y_2,Zzy_2,Y_2)),
%    send(@zyWindow,display,line(Z_2,Yzy_1,Z_2,Yzy_2)),
%    send(@xzWindow,display,line(Xxz_1,Z_3,Xxz_2,Z_3)),
%    send(@xzWindow,display,line(X_3,Zxz_1,X_3,Zxz_2)),
%    (  option(axis_points)
%    -> send(@xyWindow,display,line(X_1-5,Yxy_1+5,X_1,Yxy_1)),
%       send(@xyWindow,display,line(X_1+5,Yxy_1+5,X_1,Yxy_1)),
%       send(@xyWindow,display,line(Xxy_2-5,Y_1+5,Xxy_2,Y_1)),
%       send(@xyWindow,display,line(Xxy_2-5,Y_1-5,Xxy_2,Y_1)),
% 
%       send(@xzWindow,display,line(X_3-5,Zxz_1+5,X_3,Zxz_1)),
%       send(@xzWindow,display,line(X_3+5,Zxz_1+5,X_3,Zxz_1)),
%       send(@xzWindow,display,line(Xxz_2-5,Z_3+5,Xxz_2,Z_3)),
%       send(@xzWindow,display,line(Xxz_2-5,Z_3-5,Xxz_2,Z_3)),
% 
%       send(@zyWindow,display,line(Z_2-5,Yzy_1+5,Z_2,Yzy_1)),
%       send(@zyWindow,display,line(Z_2+5,Yzy_1+5,Z_2,Yzy_1)),
%       send(@zyWindow,display,line(Zzy_2-5,Y_1+5,Zzy_2,Y_2)),
%       send(@zyWindow,display,line(Zzy_2-5,Y_2-5,Zzy_2,Y_2)),
%       true
%    ).

degs_sin(D,S) :- degs_to_rads(D,R), sin(R,S).
degs_cos(D,S) :- degs_to_rads(D,R), cos(R,S).
degs_tan(D,S) :- degs_to_rads(D,R), tan(R,S).
degs_to_rads(D,R) :-
   R is D*3.1415 / 180.0.

% open_picture_window(Name,Title) :-
%    (  window_exist(@Name)
%    -> send(@Name,free)
%    ;  true
%    ),
%    new(@Name, picture(Title,size(300,200))),
%    send(@Name, open),
%    assertz(window_exist(Name)).

% draw_lines still need some work.
% - draw view-window, scale the points, colour?
draw_lines([]) :- !.
draw_lines([line([X1,Y1,Z1],[X2,Y2,Z2])|TailPoints]) :-
   !,
   draw_lines([line(point(X1,Y1,Z1),point(X2,Y2,Z2))|TailPoints]).
draw_lines([line(point(X1,Y1,Z1),point(X2,Y2,Z2))|TailPoints]) :-
   draw_lines(TailPoints),
   draw_line(line(point(X1,Y1,Z1),point(X2,Y2,Z2))).
draw_line(line([X1,Y1,Z1],[X2,Y2,Z2])) :-
   !,
   draw_line(line(point(X1,Y1,Z1),point(X2,Y2,Z2))).
draw_line(line(point(X1,Y1,Z1),point(X2,Y2,Z2))) :-
   !,
   win_scale(xyWindow,ScaleXY),
   win_scale(zyWindow,ScaleZY),
   win_scale(xzWindow,ScaleXZ),
   win_centre(xyWindow,[X_1,Y_1]),
   win_centre(zyWindow,[Z_2,Y_2]),
   win_centre(xzWindow,[X_3,Z_3]),
   Xxy1 is X_1 + X1*ScaleXY, Yxy1 is Y_1 - Y1*ScaleXY,
   Xxy2 is X_1 + X2*ScaleXY, Yxy2 is Y_1 - Y2*ScaleXY,

   Zzy1 is Z_2 + Z1*ScaleZY, Yzy1 is Y_2 - Y1*ScaleZY,
   Zzy2 is Z_2 + Z2*ScaleZY, Yzy2 is Y_2 - Y2*ScaleZY,

   Xxz1 is X_3 + X1*ScaleXZ, Zxz1 is Z_3 - Z1*ScaleXZ,
   Xxz2 is X_3 + X2*ScaleXZ, Zxz2 is Z_3 - Z2*ScaleXZ,
   sys_draw_line(xyWindow,Xxy1,Yxy1,Xxy2,Yxy2),
   sys_draw_line(zyWindow,Zzy1,Yzy1,Zzy2,Yzy2),
   sys_draw_line(xzWindow,Xxz1,Zxz1,Xxz2,Zxz2).
   % send(@xyWindow,display,line(Xxy1,Yxy1,Xxy2,Yxy2)),
   % send(@zyWindow,display,line(Zzy1,Yzy1,Zzy2,Yzy2)),
   % send(@xzWindow,display,line(Xxz1,Zxz1,Xxz2,Zxz2)).
   /*send(@xyWindow,display,line(X1,Y1,X2,Y2)),
   send(@zyWindow,display,line(Z1,Y1,Z2,Y2)),
   send(@xzWindow,display,line(X1,Z1,X2,Z2)).*/
draw_line(point(X1,Y1,Z1),point(X2,Y2,Z2)) :-
   draw_line(line(point(X1,Y1,Z1),point(X2,Y2,Z2))).

draw_poly_lines([]) :- !.
draw_poly_lines([_]) :- !.
draw_poly_lines([P1,P2|Ps]) :-
   draw_line(line(P1,P2)),
   !,
   draw_poly_lines([P2|Ps]).

faw :- free_all_windows.
% free_all_windows :-
%    free_window(xyWindow),
%    free_window(zyWindow),
%    free_window(xzWindow),
%    free_window(viewWindow).
% free_window(Window) :-
%    window_exist(Window),
%    send(@Window,free).
% free_window(_).

% draw_sphere(centre(Cx,Cy,Cz),radii(R,R,R)) :-
%    !,   
%    win_scale(xyWindow,ScaleXY),
%    win_scale(zyWindow,ScaleZY),
%    win_scale(xzWindow,ScaleXZ),
%    win_centre(xyWindow,[X_1,Y_1]),
%    win_centre(zyWindow,[Z_2,Y_2]),
%    win_centre(xzWindow,[X_3,Z_3]),

%    RXY is R*ScaleXY,
%    CxRealXY is X_1 + (ScaleXY*Cx - RXY)/2.0,
%    CyRealXY is Y_1 - (ScaleXY*Cy + RXY)/2.0,
%    RZY is R*ScaleZY,
%    CzRealZY is Z_2 + (ScaleZY*Cz - RZY)/2.0,
%    CyRealZY is Y_2 - (ScaleZY*Cy + RZY)/2.0,
%    RXZ is R*ScaleXZ,
%    CxRealXZ is X_3 + (ScaleXZ*Cx - RXZ)/2.0,
%    CzRealXZ is Z_3 - (ScaleXZ*Cz + RXZ)/2.0,

%    send(@xyWindow,display,circle(RXY),point(CxRealXY,CyRealXY)),
%    send(@zyWindow,display,circle(RZY),point(CzRealZY,CyRealZY)),
%    send(@xzWindow,display,circle(RXZ),point(CxRealXZ,CzRealXZ)).
% draw_sphere(centre(Cx,Cy,Cz),radii(Rx,Ry,Rz)) :-
%    CxReal is (Cx - Rx)/2.0,
%    CyReal is (Cy - Ry)/2.0,
%    CzReal is (Cz - Rz)/2.0,
%    send(@xyWindow,display,ellipse(Rx,Ry),point(CxReal,CyReal)),
%    send(@zyWindow,display,ellipse(Rz,Ry),point(CzReal,CyReal)),
%    send(@xzWindow,display,ellipse(Rx,Rz),point(CxReal,CzReal)).

% expressions ought to be scanned for clock, x,y,z and declareds before
% being evaluated. Feel free to do so...
transform_point(translate(X,Y,Z),point(X1,Y1,Z1),point(X2,Y2,Z2)) :-
   !,
   X2 is X1+X,
   Y2 is Y1+Y,
   Z2 is Z1+Z.
transform_point(scale(X,Y,Z),point(X1,Y1,Z1),point(X2,Y2,Z2)) :-
   !,
   X2 is X1*X,
   Y2 is Y1*Y,
   Z2 is Z1*Z.
transform_point(rotate(X0,Y0,Z0),point(X1,Y1,Z1),point(XR,YR,ZR)) :-
   !,
   degs_to_rads(X0,X),
   degs_to_rads(Y0,Y),
   degs_to_rads(Z0,Z),
   Cos1 is cos(X), Sin1 is sin(X),
   Cos2 is cos(Y), Sin2 is sin(Y),
   Cos3 is cos(Z), Sin3 is sin(Z),
   Y3 is Y1*Cos1-Z1*Sin1, Z2 is  Y1*Sin1+Z1*Cos1, % X2=X1
   X3 is X1*Cos2+Z1*Sin2, ZR is -X1*Sin2+Z2*Cos2, % Y3=Y2
   XR is X3*Cos3-Y3*Sin3, YR is  X3*Sin3+Y3*Cos3. % ZR=Z3
transform_point(_,P,P) :- !.   % texture, whatnot....

transform_points_2(_, [],[]).% :- !. %% Green cut - but speeds up some compilers
transform_points_2(Operation, [P1|Ps],[P1R|PRs]) :-
   transform_point(Operation,P1,P1R),
   transform_points_2(Operation, Ps,PRs).

transform_points([],P,P) :- !.
transform_points([Op|Ops], Ps,PRs) :-
   transform_points_2(Op,Ps,PsR),
   transform_points(Ops, PsR,PRs).

% cls(A) :-
%    send(@A,clear).
% clss :-
%    clear_windows.
% clear_windows :-
%    forall( window_exist(A), ignore(send(@A,clear))),
/*
   send(@xyWindow,clear),
   send(@zyWindow,clear),
   send(@xzWindow,clear),
   send(@viewWindow,clear),
   */
%   draw_axis.

declared(Name) :-
   declared(_,Name,_,_),
   !.
%declared(Name) :-
%   Name =.. [Name2,_],
%   declared(_,N,_,_),
%   \+ N =.. [_],           % don't bother checking arity 0 declares!
%   N =.. [Name3,_],
%   ( Name2 = Name3 ; string_to_atom(Name2,Name3) ).
declared(Name,Type,Body) :-
   var(Name),
   !,
   declared(_,Atom,Type,Body),
   string_to_atom(Name,Atom).
declared(Name,Type,Body) :-
   declared(_,Name,Type,Body).

%% delcared/4 is the 'official' interface to declared. information hiding,
%% if you like. Abstract data types, if you don't
declared(Status, Name, Type, Body) :-
   recorded(declared,[Status, N, Type, Body]),
   (  N =.. [_]            % arity zero.
   -> ( N = Name ; string_to_atom(Name,N) ),
      !
   ;  N =.. [Name3,_],
      ( Name = Name3 ; string_to_atom(Name,Name3) ),
      !
   ).

new_declared2(Window,Name,Body) :-    % needed for the graphics interface
   term_to_atom(Bod,Body),
   term_to_atom(Nam,Name),
   writef('\n\n\nPING PONG! This routine IS called!\n'),
   (  Nam =.. [_,_|_]
   -> send(Window, report, warning, 'No GUI for parameterised declares!')
   ;  new_declared(Nam,Bod)
   ).
declare(Name,Body) :- new_declared(Name,Body).
nd(Name,Body) :- new_declared(Name,Body).
new_declared(Name,Body) :-
   Body =.. [Type|_],
   flag(reading_file,Status,Status),
   new_declared(Status,Name,Type,Body).
new_declared(Name,Type,Body) :-
   flag(reading_file,Status,Status),
   new_declared(Status,Name,Type,Body).
new_declared(_,Name,_,_) :-
   Name =.. [_],       %% i.e. not parameterised declared - messes up string_to_whatever
   declared(Name,_,_),
   !,
   % string_to_list(Name,List1),
   % string_to_list(' is already declared!', List2),
   % append(List1," is already declared!",List),
   % string_to_list(ErrorString,List),
   swritef(ErrorString,'%w is already declared!',Name),
   message(errorWindow,ErrorString).

% Whee! This is the parameterised declared!
new_declared(Status,Name,Type,Body) :-
   Name =.. [Name|Vars],
   \+ Vars = [],  % i.e. not Name = function, but Name = function(s,m,....)
   !,
   % assertz(declared(Status,Name,Type,Body)),
   recordz(declared,[Status,Name,Type,Body]),
   information('declared '), information(Name),
   information(' which is of type '),information(Type),
   % information([Name,Type]), % ,Body]),
   information(nl).
   /*
   (  Status = included  %New
   -> recordz(included_source,Object2)  %New
   ;  recordz(source,Object2)  %New
   ),  %New
   */
new_declared(Status,Name,Type,Body) :-
   % assertz(declared(Status,Name,Type,Body)),
   recordz(declared,[Status,Name,Type,Body]),
   information('declared '), information(Name),
   information(' which is of type '),information(Type),
   % information([Name,Type]), % ,Body]),
   information(nl).

information(nl):-!,nl.
information(A) :- 
   swritef(S,A),
   string_to_list(S,S2),
   length(S2,L),
   (  L<160
   -> write(S)
   ;  (L>3600 -> true ;    %% if L is too large, system will crash!
      length(S3,160),
      append(S3,_,S2),
      string_to_list(S4,S3),
      write(S4)
   )).
information(token_list,Wot) :-
   !,
   string_to_list(String,Wot),
   write('@@'),write(String).
information(A,B) :- 
   swritef(S,A,B),
   information(S).
/*
information(token_list,Text,Wot) :-
   !,
   string_to_list(String,Wot),
   write(Text),write(': '),write(String).
information(parse,Text,Wot) :-
   !,
   write(Text), write(': '), write(Wot),nl.
information(parse1,Text,Wot) :-
   !,
   write(Text), write(': '), write(Wot),nl.
information(parse2,Text,Wot) :-
   !,
   write(Text), write(': '), write(Wot),nl.
*/
information(_,_,_) :- true.
/*information(debug,Text,Wot) :-
   write(Text), write(': '),
   string_to_list(String,Wot), write(String),nl.
*/

nso(Object) :- new_screen_object(Object).
new_screen_object2(Object) :-
   term_to_atom(Obj, Object),
   !,
   new_screen_object(Obj).
new_screen_object(Object) :-
   option(reading_file,Status),
   !,
   new_screen_object(Status,Object).
new_screen_object(_Status,Object) :-
   screen_object(Object),              % does it already exist?
   !,
   message(errorWindow,'Duplicate object error!').
new_screen_object(Status,Object) :-
   minimise_object(Object,Object2),
   % assertz(screen_object(Status,Object2)), %Old
   (  Status = included  %New
   -> recordz(included_source,Object2)  %New
   ;  recordz(source,Object2)  %New
   ),  %New
   ignore((
      option(display_graphics,true),
      display_object(Object2)
   )).
screen_object(Object) :-  %% Does object already exist?
   recorded(included,Object)
   ; recorded(source,Object).
dsot(O) :- delete_screen_object_type(O).
delete_screen_object_type(ObjectType) :-
   writef('Deleting objects of type %t...\n',[ObjectType]),
   (  recorded(source,O,Ref),
      O =.. [ObjectType|_],
      erase(Ref),
      fail
   ;  true
   ).

dso(O) :- delete_screen_object(O).
delete_screen_object(Object) :-
   ( recorded(source,Object,R) ; recorded(included,Object,R)) ,
   !,
   erase(R).
   % screen_object(Incl,Object),
   % retract(screen_object(Incl,Object)).
   % Object =.. [Type|_],
   % true. % writef('Successful deletion of %t.\n',[Type]).

minimise_object(Object,Object). % 2) :-
%    Object2 = Object.

get_float(float(F),F) :- get_float(F),!.
get_float(F,F) :- float(F);integer(F),!.
get_float(F,Fl) :- declared(_,F,float,Fl),!.
get_float(F,Fl) :- declared(_,F,float,float(Fl)).
 
display :- do_display.
do_display :- set_option(display_graphics,true).
dont_display :- set_option(display_graphics,false).

is_white(32). % space
is_white(9).  % tab
is_white(10). % newline
is_white(13). % Linefeed. or is that the other way around?

is_digit(48). % 0
is_digit(49). % 1
is_digit(50).
is_digit(51).
is_digit(52).
is_digit(53).
is_digit(54).
is_digit(55).
is_digit(56).
is_digit(57).

capov_load(A) :- consult(A).
redraw :- clss, display_objects.

option(O,V) :- flag(O,V,V),!.
set_option(O,V) :- flag(O,_,V),!.

include_file(FileName) :- 
   var(FileName),
   !,
   recorded(capov_include_files,FileName).
include_file(none) :-
   recorded(capov_include_files,_F,R),
   erase(R),
   fail
   ;
   !,true.
include_file(FileName) :-
   recordz(capov_include_files,FileName).
%include_files(F) :- recorded(capov_include_files,F).

povray :-
   get_povray_string(' ',String),
   swritef(Command, 'povray -d %w >& /dev/null &', [String] ),
   writef('Launching %w\n',[Command]),
   shell(Command).
povray(User) :-
   get_povray_string(User,String),
   swritef(Command, 'povray -d %w >& /dev/null &', [String] ),
   writef('Launching %w\n',[Command]),
   shell(Command).
xpovray :-
   get_povray_string(' ',String),
   write(String),nl,
   swritef(Command, 'xpovray +d %w >& /dev/null &', [String] ),
   writef('Launching %w\n',[Command]),
   shell(Command).
xpovray(User) :-
   get_povray_string(User,String),
   swritef(Command, 'xpovray +d %w >& /dev/null &', [String] ),
   writef('Launching %w\n',[Command]),
   shell(Command).
get_povray_string(User,String) :-
   capov(output_name,FileName),
   option(povray_alias,Alias),
   option(povray_aliasing,Aliasing2),
   Aliasing is Aliasing2/10.0,
   option(povray_width,Width),
   option(povray_height,Height),
   option(povray_home,PovrayHome),
   swritef(String,'-i/home/radar/prolog/capov/%w %ta%t -w%t -h%t -o/tmp/capov.tga +l%w -v %w',
      [FileName,Alias,Aliasing,Width,Height,PovrayHome,User]
   ).
