% :- dynamic option/1.
:- set_option(cube_faces,false).
:- set_option(axis_points,true).              % true or false
:- set_option(cylinder_edges,8).              
:- set_option(edges,8).                       % for cylinders, circles, and wotnot
:- set_option(minor_edges,6).                 % for torus
:- set_option(major_edges,8).                 % for torus
:- set_option(triangulated_cylinder,false).
:- set_option(window_size,80).
:- set_option(light_source_size,6).
:- set_option(display_graphics,true).
:- set_option(display_lightsource,false).
:- set_option(hierarchy,detailed). % flag(hierarchy,_,names_only).

:- set_option(win_scale_xy,500).
:- set_option(win_scale_zy,500).
:- set_option(win_scale_xz,500).

:- set_option(output_name,'output.pov').
:- set_option(dump_name,'dump.pl').
:- include_file('colors.inc').
:- include_file('textures.inc').

%% Options for PovRay
:- set_option(povray_alias,'-').   %% or '+'
:- set_option(povray_aliasing,3).  %% between 0.0 and 3.0 - however, as
                               %% 'set_option/3' needs an int, multiply by 10
:- set_option(povray_width,320).
:- set_option(povray_height,200).
:- set_option(povray_home,'/home/povray/pov/include'). %% where texture.inc and the rest live.


