:- discontiguous save_something_povray2/3.

% capov(output_name,'output.pov').
% capov(dump_name,'dump.pl').

% include_files('colors.inc').
% include_files('textures.inc').

restore_prolog :-
   capov(dump_name,A),
   restore_prolog(A).
restore_prolog(A) :-
   consult(A).

dump :-
   option(dump_name,F),
   dump2(F).
dump(FileName) :-
   (  FileName = [_|_]
   -> string_to_atom(FileName,File),
      set_option(dump_name,File)
   ;  set_option(dump_name,FileName)
   ),
   dump2(FileName).
dump2(FileName) :-
   writef('Dumping to %t...\n',[FileName]),
   tell(FileName),
   % ignore(listing(include_files)),  %% Now IN ERROR
   ignore( bagof( A, (
            include_file(A),
            writef(':- record(source,%t).\n',[A])
   ), _ ) ),
   nl,
   % ignore(listing(declared/4)),     %% Now IN ERROR
   ignore( bagof( [I,N,T,D], (
            declared(I,N,T,D),
            writef(':- record(new_declared(%t,%t,%t,%t).\n',[I,N,T,D])
   ), _ ) ),
   nl,
   % ignore(listing(screen_object/2)),
   ignore( bagof( A, (
            recorded(included,A),
            writef(':- record(included,%t).\n',[A])
   ), _ ) ),
   ignore( bagof( A, (
            recorded(source,A),
            writef(':- record(source,%t).\n',[A])
   ), _ ) ),
   told.

save(FileName) :-
   % capov(save_format,povray2),
   !,
   (  FileName = [_|_]
   -> string_to_atom(FileName,File),
      set_option(output_name,File)
   ;  set_option(output_name,FileName)
   ),
   save_povray2(FileName).
save :-
   % capov(save_format,povray2),
   save_povray2.
save_povray2 :-
   option(output_name,FileName),
   save_povray2(FileName).

save_povray2(FileName) :-
   writef('Preparing to save to %t...\n',[FileName]),
   % ignore(  bagof( I, include_files(I), Includes) ),
   writef('Collecting declares...\n'),
   % ignore(  bagof([Name,Type,Def], declared(not_included,Name,Type,Def), Declareds) ),
   % ignore(  bagof( L, light_source(not_included,L), Lights) ),
   writef('Collecting screen objects...\n'),
   %ignore( bagof( SO, recorded(included,SO), Objects1 ) ),
   %ignore( bagof( SO, recorded(source,SO), Objects2 ) ),
   %ignore(append(Objects1,Objects2,Objects)),
   % ignore(  bagof( SO, screen_object(not_included,SO), Objects) ),
   !,
   writef('Ok, saving. No feedback will be given during save.\n'),
   tell(FileName),
   ignore(save_includes_povray2),
   ignore(save_declareds_povray2), 
   % ignore(save_camera_povray2), 
   % ignore(save_light_sources_povray2(Lights)), 
   ignore(save_screen_objects_povray2), 
   told,
   writef('%t saved.',[FileName]),nl,
   erase_all(written_declared).

save_includes_povray2 :-
   include_file(H),
   writef('#include "%w"\n',[H]),
   fail.
save_includes_povray2 :- nl.
   
save_declareds_povray2 :-
   declared(source,N,T,D),
   save_declared_povray2(N,T,D),
   % save_declareds_povray2,
   fail.
   % save_declareds_povray2(Tail).
save_declareds_povray2 :- !,nl.

save_declared_povray2(Name,_,Def) :-
   Name =.. [Name],
   !,
   (( nfdnt(Name,File,_,Needs,_), 
      \+ recorded(written_declared,Name), 
      \+ recorded(included_file,File) )
   -> forall( member(N,Needs), (
         nfdn(N,_,D,_),
         save_declared_povray2(N,_,D)
      ))
   ;  true
   ),
   write('#declare '),
   write(Name), write(' = '), % nl,
   (  Def =.. [ObjType,Body] ; Def =.. [ObjType|Body] ),
   !,
   save_something_povray2(ObjType,Body,3),
   recordz(written_declared,Name),
   nl.
save_declared_povray2(Name,_,_) :-
   Name =.. [Name2|_],
   !,
   writef('// %t is automatically expanded...',[Name2]),
   nl.

%save_screen_objects_povray2(A) :- var(A), !, fail.
%save_screen_objects_povray2([]).
save_screen_objects_povray2 :-
   (( recorded(included,Obj) ; recorded(source,Obj)),
      Obj =.. [Op|Bod],
      (  member(Op,[camera])   % to be extended?
      -> save_something_povray2(Op,Bod,0)
      ;  write('object {'),nl,
         save_something_povray2(Op,Bod,3),
         write('}')
      ),nl,nl,
      fail
   ) ; true.
   %save_screen_objects_povray2(Objs).
   %write(Objects),nl.
save_screen_object_povray2(Obj) :-
   Obj =.. [ObjType|Descr],
   write('object {'),nl,
   save_something_povray2(ObjType,Descr,3),
   %save_object_povray2(ObjType,Descr,3),
   write('}'),nl.

/*
adaptive
agate
agate_turb
all,Ta ?
%alpha
ambient
area_light  - complex... need proper syntax (arealight([bc(),tc(),n1(1),n2()]))
background - ?
bicubic_patch - ugh. wait a bit...
blue
bounded_by
box
bozo
brilliance
bumps
bump_size
camera
checker
clipped_by
clock
colour
colour_map - not implemented!
component - ?
cone
crand
cubic - .... later, that same day, ...
cylinder
declare
default - ...
height_field - ...
hexagon
iff - ?
image_map - ?
include - ?
interpolate
intersection
inverse
ior
jittter
lambda
leopard
light_source
location
looks_like
look_at
mandel
map_type
marble
material_map - ?
max_intersections
max_trace_level
merge
metallic
normal
no_shadow
object
octaves
omega
once
onion
open
phase
phong
rgbf
right
ripples
rotate
roughness
scale
sky
smooth - ??
smooth_triangle - ?
specular
sphere
spotlight
spotted
sturm
texture
tga - ?
threshold
tightness
tile2 - ?
tiles - ?
torus
translate
triangle - ?
turbulence
type - I'm assuming this takes an int (well, float, anyway)
union
up
use_colour - ?
use_index - ?
u_steps - ?
version - Not implemented. Nor likely to be, at the moment
v_steps - ?
water_level - ?
dents
difference
diffuse
direction
disc - ?
distance
dump - ??
falloff
filter
finish
flatness
fog
frequency
gif - ?
gradient - ?
green
phong_size
pigment
plane
point_at
poly - ?
pot - ?
quadric - ?
quartic - ?
quick_colour - ?
radial - ?
radius
raw
red
reflection
refraction
rgb
waves
wood
wrinkles
x
y
z
*/

save_something_povray2(N,[[B|C]],T) :- 
   !,
   save_something_povray2(N,[B|C],T).

save_something_povray2([],_,_) :- !.

% Words with an arity of zero...
save_something_povray2(Word,Body,Tabs) :-
   member(Word,[ agate,
                 inverse,
                 bozo,
                 wood,
                 dents,
                 marble,
                 metallic,
                 no_shadow,
                 area_light,
                 once,
                 jitter, % according to the docs, 'jitter' takes no arg
                 onion,
                 open,
                 leopard,
                 ripples,
                 spotted,
                 spotlight,
                 sturm
                 ]),
   !,
   tab(Tabs), write(Word),
   (  Body=[]
   -> true
   ;  writef('   // %t ignored.',[Body])
   ),
   nl.

% these keywords take a single float
save_something_povray2(Word,Body,Tabs) :-
   member(Word,[ ambient,
                 adaptive,
                 interpolate,
                 max_intersections,
                 falloff,
                 wrinkles,
                 tightness,
                 max_trace_level,
                 phase,
                 phong,
                 agate_turb,
                 lambda,
                 brilliance,
                 bumps,
                 distance,
                 flatness,
                 fog,
                 bump_size,
                 omega,
                 crand,
                 filter,
                 ior,
                 % jitter,
                 octaves,
                 mandel,
                 map_type,
                 type,
                 phong_size,
                 ripples,
                 roughness,
                 specular,
                 turbulence,
                 diffuse,
                 frequency,
                 reflection,
                 refraction,
                 green, red, blue,  % not sure if these are used at this moment in time...
                 waves
                 ]),
   !,
   tab(Tabs), writef('%t ',[Word]),
   save_something_povray2(float,Body),
   nl.

% these keywords take a single vector
save_something_povray2(Word,Body,Tabs) :-
   member(Word,[ location,
                 look_at,
                 right,
                 rotate,
                 up,
                 sky,
                 direction,
                 scale,
                 translate
                 ]),
   !,
   tab(Tabs), writef('%t ',[Word]),
   save_something_povray2(vector,Body),
   nl.

save_something_povray2(Word,Body,Tabs) :-
   member(Word,[ box,
                 bounded_by,
                 clipped_by,
                 finish,
                 normal,
                 quadric,
                 quartic,
                 pigment,
                 sphere,
                 plane,
                 torus,
                 looks_like,
                 cone,
                 checker,  % well, syntactically this may be heresy,
                 hexagon,  % but let's not judge the user too soon.
                 colour_map,
                 intersection,
                 cylinder,
                 camera,
                 triangle,
                 smooth_triangle,
                 union,
                 merge,
                 difference,
                 light_source,
                 object,
                 texture]),
   !,
   tab(Tabs),
   Tabs2 is Tabs +3,
   append([FirstThing],Rest,Body),
   (  member(Word,[torus,cone,plane,sphere,box,cylinder,light_source])
   -> writef('%t { ',[Word]),
      FirstThing =.. [Op2|Bod2],
      save_something_povray2(Op2,Bod2,0)
   ;  writef('%t {\n',[Word]),
      % tab(Tabs2),
      FirstThing =.. [Op2|Bod2],
      save_something_povray2(Op2,Bod2,Tabs2)
   ),
   forall(
      member(M,Rest),
      (  M =.. [Op|Bod],
         % write([M,Op,Bod]),nl,
         save_something_povray2(Op,Bod,Tabs2)
      )
   ),
   tab(Tabs), write('}'),nl.

save_something_povray2(Word,Body,_Tab) :-
   member(Word,[vector,bc,start,end]),
   !,
   % tab(Tab),
   save_something_povray2(vector,Body),
   write(', ').

save_something_povray2(vertices,Body,Tab) :-
   tab(Tab),
   (  Body=[A,B,C] 
   -> save_something_povray2(vector,A),
      write(', '),
      save_something_povray2(vector,B),
      write(', '),
      save_something_povray2(vector,C),
      nl
   ;  Body=[A,B,C,D,E,F],
      save_something_povray2(vector,A),
      write(', '),
      save_something_povray2(vector,B),
      write(', '),nl,
      tab(Tab),
      save_something_povray2(vector,C),
      write(', '),
      save_something_povray2(vector,D),
      write(', '),nl,
      tab(Tab),
      save_something_povray2(vector,E),
      write(', '),
      save_something_povray2(vector,F),
      nl
   ).

% words which take a vector not used by povray
% these are words which I find useful - but which povray doesn't need.
save_something_povray2(Word,Body,_) :-
   member(Word,[ centre,
                 tc,
                 position
               ]),
   % -> tab(Tabs), writef('%t ',[Word])
   % ;  member(Word,[tc, position ])
      % % writef('%t ',[Word])
   % ),
   save_something_povray2(vector,Body),
   (  member(Word,[centre,maj_rad,major_radius ])
   -> write(', ')
   ;  nl
   ).

%save_something_povray2(centre,Body,_) :-
%   !,
%   save_something_povray2(vector,Body),
%   write(' ').
save_something_povray2(Word,Body,_) :-
   member(Word,[ radius,
                 n1,n2,
                 float,
                 radius2,
                 radius1,
                 float,
                 minor_radius, min_rad,
                 major_radius, maj_rad
               ]),
   !,
   save_something_povray2(float,Body),
   (  member(Word,[radius1,maj_rad,major_radius,n1 ])
   -> write(', ')
   ;  nl
   ).
%   nl.

%save_something_povray2(Word,Rot,Tabs) :-
%   member(Word,[rotate,translate,scale]),
%   !,
%   %   write(hello),nl,
%   tab(Tabs),
%   write(Word), write(' '),
%   save_something_povray2(vector,Rot),
%   nl.

save_something_povray2(colour,Body,Tabs) :-
   my_tab(Tabs),
   write('colour '),
   (( Body = [rgb(X,Y,Z)] ; Body = rgb(X,Y,Z) )
   -> write('rgb '),
      save_something_povray2(vector,[X,Y,Z])
   ; (  Body = [rgbf(X,Y,Z,F)]
     -> writef('rgbf <%w, %w, %w, %w>',[X,Y,Z,F])   
     ; (( [Bod] = Body, declared(Bod,colour,_), Bod =.. [_|[]] )
       -> write(Bod)
       ;  write(notyet),write(Body),declared(A,colour,_),write(A),nl
       )
     )
   ),
   (  Tabs > -1 -> nl ; true).

% 'composite' vectors are a major headache at this moment in time.
% let me sleep on it. Until then, don't add vectors, or do anything equally
% interesting
save_something_povray2(vector,[A*vector(X,Y,Z)]) :-
   !,
   save_something_povray2(float,[A]),
   writef(' * <%w, %w, %w>',[X,Y,Z]).

%save_something_povray2(vector,[A/vector(X,Y,Z)]) :-
%   !,
%   save_something_povray2(float,[A]),
%   writef(' / <%w, %w, %w>',[X,Y,Z]).
%save_something_povray2(vector,[A+vector(X,Y,Z)]) :-
%   !,
%   writef('%w + <%w, %w, %w>',[A,X,Y,Z]).
%save_something_povray2(vector,[A-vector(X,Y,Z)]) :-
%   !,
%   writef('%w - <%w, %w, %w>',[A,X,Y,Z]).

save_something_povray2(vector,[vector(X,Y,Z)]) :-
   !,
   writef('<%w, %w, %w>',[X,Y,Z]).
save_something_povray2(vector,[X,Y,Z]) :-
   !,
   writef('<%w, %w, %w>',[X,Y,Z]).
save_something_povray2(vector,A) :-
   ( A = [B] ; A = B),
   member(B,[x,y,z]),
   writef('%w',[B]).
save_something_povray2(vector,[A]) :-
   declared(A),
   !,
   write(A),nl.

save_something_povray2(float,[X]) :-
   !,
   writef('%w',[X]).
save_something_povray2(float,A) :-
   ( A = [B] ; A = B),
   member(B,[clock]),      % silly to use member? easier to expand later
   writef('%w',[B]).

save_something_povray2(vector,[X,Y,Z],_Tabs) :-
   !,
   writef('<%w, %w, %w>',[X,Y,Z]).
save_something_povray2(Name,Bod,Tabs) :-
   Name =.. [_|[]],    % arity 0 - that is, no hollow(1,2)
   declared(Name),
   !,
   tab(Tabs),write(Name),nl,
   forall(
      member(A,Bod),
      (  A =.. [Op|B],
         save_something_povray2(Op,B,Tabs)
      )
   ).
   
save_something_povray2(colour_entry,Body,Tab) :-
   !,
   dummy,
   tab(Tab),
   (  Body = [F,colour(C)]
   -> get_float(F,Fl),
      writef('[%t, ',[Fl]),
      save_something_povray2(colour,[C],-1),
      writef(']\n')
   ;  Body = [F1,F2,colour(C1),colour(C2)],   %% It had better be!
      get_float(F1,Fl1),
      get_float(F2,Fl2),
      writef('[%t, %t, ',[Fl1,Fl2]),
      save_something_povray2(colour,[C1],-1),
      save_something_povray2(colour,[C2],-1),
      writef(']\n')
   ).

% and this is my treat - hollow(1,2,[rest_of_objects]) or
%                        hollow(3,4)
save_something_povray2(Name,Bod,Tabs) :-
   declared(_,Name2,_Type,Body),
   Name2 =.. [Name|Args2],
   !,
   % dummy,
   Body =.. [Type,Description],
   length(Bod,L1),
   length(Args2,L2),
   (  L1 =:= L2
   -> Bod = Args2,           % binding the variables...
      save_something_povray2(Type,Description,Tabs)
   ;  L1 =:= L2+1,
      append(Args3,[Rest],Bod), 
      Args2 = Args3,         % binding the variables...
      (  Rest =.. ['.'|_]    % ...is Rest a list? Hm. Rest = [_|_] would work just as well, of course...
      -> append(Description,Rest,Body2)
      ;  append(Description,[Rest],Body2)
      ),
      save_something_povray2(Type,Body2,Tabs)
   ).
  
save_something_povray2(_Name,Bod,Tabs) :-
   % is 'Name' something that can be declared?
   % member(Name,[float,vector,object,colour,pigment,finish,normal,
   %              texture,camera,colour_map,transform]),
   %%%%% Don't worry about testing the integrity.... IUIQ, kinda thing...
   %!,   % Right!
   % dummy,
   % in which case it's body and should either be a declared name or... um.
   (  declared(Bod)
   -> tab(Tabs),write(Bod)
   ;  B = [Bod],
      declared(B),
      tab(Tabs),write(B)  
   ).
   
save_something_povray2(Name,[],Tabs) :-
   %% Ok, SO I don't know what the Dickens we're dealing with.
   %% Let's just write it and hope the user know what's intended!
   !,
   tab(Tabs),write(Name),
   write(' // WARNING! This may not make sense.'),nl.

my_tab(T) :- T<0,!.
my_tab(T) :- tab(T).
