initialize_system :-
   retractall(window_handle(_,_)),
   open_picture_window(zyWindow,'ZY Plane'),
%   open_picture_window(viewWindow,'Perspective View'),
   open_picture_window(xyWindow,'XY Plane'),
   open_picture_window(xzWindow,'XZ Plane'),
   draw_axis,
   top_level.

draw_axis :-
   option(window_size,Size),
   win_centre(xyWindow,[X_1,Y_1]),
   win_centre(zyWindow,[Z_2,Y_2]),
   win_centre(xzWindow,[X_3,Z_3]),
   Xxy_1 is X_1 - Size, Xxy_2 is X_1 + Size,
   Yxy_1 is Y_1 - Size, Yxy_2 is Y_1 + Size,
   Zzy_1 is Z_2 - Size, Zzy_2 is Z_2 + Size,
   Yzy_1 is Y_2 - Size, Yzy_2 is Y_2 + Size,
   Xxz_1 is X_3 - Size, Xxz_2 is X_3 + Size,
   Zxz_1 is Z_3 - Size, Zxz_2 is Z_3 + Size,
   send(@xyWindow,display,line(Xxy_1,Y_1,Xxy_2,Y_1)),
   send(@xyWindow,display,line(X_1,Yxy_1,X_1,Yxy_2)),
   send(@zyWindow,display,line(Zzy_1,Y_2,Zzy_2,Y_2)),
   send(@zyWindow,display,line(Z_2,Yzy_1,Z_2,Yzy_2)),
   send(@xzWindow,display,line(Xxz_1,Z_3,Xxz_2,Z_3)),
   send(@xzWindow,display,line(X_3,Zxz_1,X_3,Zxz_2)),
   (  option(axis_points,true)
   -> send(@xyWindow,display,line(X_1-5,Yxy_1+5,X_1,Yxy_1)),
      send(@xyWindow,display,line(X_1+5,Yxy_1+5,X_1,Yxy_1)),
      send(@xyWindow,display,line(Xxy_2-5,Y_1+5,Xxy_2,Y_1)),
      send(@xyWindow,display,line(Xxy_2-5,Y_1-5,Xxy_2,Y_1)),

      send(@xzWindow,display,line(X_3-5,Zxz_1+5,X_3,Zxz_1)),
      send(@xzWindow,display,line(X_3+5,Zxz_1+5,X_3,Zxz_1)),
      send(@xzWindow,display,line(Xxz_2-5,Z_3+5,Xxz_2,Z_3)),
      send(@xzWindow,display,line(Xxz_2-5,Z_3-5,Xxz_2,Z_3)),

      send(@zyWindow,display,line(Z_2-5,Yzy_1+5,Z_2,Yzy_1)),
      send(@zyWindow,display,line(Z_2+5,Yzy_1+5,Z_2,Yzy_1)),
      send(@zyWindow,display,line(Zzy_2-5,Y_1+5,Zzy_2,Y_2)),
      send(@zyWindow,display,line(Zzy_2-5,Y_2-5,Zzy_2,Y_2)),
      true
   ).
open_picture_window(Name,Title) :-
   (  window_exist(@Name)
   -> send(@Name,free)
   ;  true
   ),
   new(@Name, picture(Title,size(300,200))),
   send(@Name, open),
   assertz(window_exist(Name)).

free_all_windows :-
   free_window(xyWindow),
   free_window(zyWindow),
   free_window(xzWindow),
   free_window(viewWindow).
free_window(Window) :-
   window_exist(Window),
   send(@Window,free).
free_window(_).

%% Draw a line in a specified window
sys_draw_line(Window,X1,Y1,X2,Y2) :-
   send(@Window,display,line(X1,Y1,X2,Y2)).

draw_sphere(centre(Cx,Cy,Cz),radii(R,R,R)) :-
   !,   
   win_scale(xyWindow,ScaleXY),
   win_scale(zyWindow,ScaleZY),
   win_scale(xzWindow,ScaleXZ),
   win_centre(xyWindow,[X_1,Y_1]),
   win_centre(zyWindow,[Z_2,Y_2]),
   win_centre(xzWindow,[X_3,Z_3]),

   RXY is 2*R*ScaleXY,
   CxRealXY is X_1 + ScaleXY*Cx - RXY/2.0,
   CyRealXY is Y_1 - ScaleXY*Cy - RXY/2.0,
   RZY is 2*R*ScaleZY,
   CzRealZY is Z_2 + ScaleZY*Cz - RZY/2.0,
   CyRealZY is Y_2 - ScaleZY*Cy - RZY/2.0,
   RXZ is 2*R*ScaleXZ,
   CxRealXZ is X_3 + ScaleXZ*Cx - RXZ/2.0,
   CzRealXZ is Z_3 - ScaleXZ*Cz - RXZ/2.0,

   send(@xyWindow,display,circle(RXY),point(CxRealXY,CyRealXY)),
   send(@zyWindow,display,circle(RZY),point(CzRealZY,CyRealZY)),
   send(@xzWindow,display,circle(RXZ),point(CxRealXZ,CzRealXZ)).
draw_sphere(centre(Cx,Cy,Cz),radii(Rx,Ry,Rz)) :-
   CxReal is (Cx - Rx)/2.0,
   CyReal is (Cy - Ry)/2.0,
   CzReal is (Cz - Rz)/2.0,
   send(@xyWindow,display,ellipse(Rx,Ry),point(CxReal,CyReal)),
   send(@zyWindow,display,ellipse(Rz,Ry),point(CzReal,CyReal)),
   send(@xzWindow,display,ellipse(Rx,Rz),point(CxReal,CzReal)).

cls(A) :-
   send(@A,clear).
clss :-
   clear_screens.
clear_screens :-
   forall( window_exist(A), ignore(send(@A,clear))),
   draw_axis.
