vector_addition([X1,Y1,Z1],[X2,Y2,Z2],[Rx,Ry,Rz]) :-
   Rx is X1+X2,
   Ry is Y1+Y2,
   Rz is Z1+Z2.
vector_addition(vector(X1,Y1,Z1),vector(X2,Y2,Z2),vector(Rx,Ry,Rz)) :-
   Rx is X1+X2,
   Ry is Y1+Y2,
   Rz is Z1+Z2.

vector_difference([X1,Y1,Z1],[X2,Y2,Z2],[Rx,Ry,Rz]) :-
   Rx is X1-X2,
   Ry is Y1-Y2,
   Rz is Z1-Z2.
vector_difference(vector(X1,Y1,Z1),vector(X2,Y2,Z2),vector(Rx,Ry,Rz)) :-
   Rx is X1-X2,
   Ry is Y1-Y2,
   Rz is Z1-Z2.

vector_divide_float([X1,Y1,Z1],F,[Rx,Ry,Rz]) :-
   Rx is X1/F,
   Ry is Y1/F,
   Rz is Z1/F.
vector_divide_float(vector(X1,Y1,Z1),F,vector(Rx,Ry,Rz)) :-
   Rx is X1/F,
   Ry is Y1/F,
   Rz is Z1/F.

vector_magnitude(vector(X,Y,Z),M) :-
   M is sqrt(X*X + Y*Y + Z*Z).
vector_magnitude([X,Y,Z],M) :-
   vector_magnitude(vector(X,Y,Z),M).

get_unit_vector(V,V2) :-
   vector_magnitude(V,M),
   vector_divide_float(V,M,V2).

vector_angles(V,Alpha,Beta) :-
   ( vector(0,Y,0) = V ; [0,Y,0]=V ),
   !,
   ( Y < 0 -> Alpha = -180 ;  Alpha = 180 ), Beta=0.
vector_angles(V,Alpha,Beta) :-
   ( vector(X,0,0) = V ; [X,0,0]=V ),
   !,
   ( X < 0 -> Beta = 90 ; Beta = -90), Alpha=0.
vector_angles(V,Alpha,Beta) :-
   ( vector(0,0,Z) = V ; [0,0,Z]=V ),
   !,
   ( Z < 0 -> Alpha = -90 ; Alpha = 90), Beta=0.
vector_angles(V,Alpha,Beta) :-
   ( vector(X,Y,Z) = V ; [X,Y,Z]=V ),
   !,
   (  Y = 0 -> Alpha = 0 ; Alpha is atan(Z/Y)*180/3.1415 ),
   (  X = 0 -> Beta = 0 ; Beta is atan(Y/X)*180/3.1415 ).
   %writef('Alpha-Beta %t %t\n',[Alpha,Beta]).

